:CONFIG
set procom=acp
if "%errorlevel%"=="9009" set procom=pro
if not exist "%windir%\system32\choice.exe" set procom=pro

set map=
set tmp=laby.tmp
set title=laby v0.1b
title %title% %map%
mode con cols=40 lines=31
color 0F
@echo off

:CHOIX
cls
echo.
echo.
echo.
echo                  LABY
echo                    v0.1b
echo.
echo.
echo.
echo.
echo 
echo.
echo  Choisissez une map :
echo.
for /f %%i in ('DIR .\maps\*.laby /b') do echo    - %%~ni
echo.
echo    - scores
echo    - quitter
echo.
echo  Tapez le nom de la map :
set /p map=
if %map%==quitter goto QUIT
if %map%==quit goto QUIT
if %map%==exit goto QUIT
if %map%==scores goto SCORES
if %map%==score goto SCORES
if not exist .\maps\%map%.laby (
   echo  La map n'existe pas !
   goto CHOIX
)

rem  INIT
set score_map=%map%
set map=.\maps\%map%.laby
set go=LOAD
set win=0
set rep=0

:START
find "NAME" %map% > %tmp%
cls
echo.
echo.
echo           *** INFORMATIONS ***
echo.
for /f "tokens=2 delims=;" %%i in (%tmp%) do echo  Nom : %%i
for /f "tokens=3 delims=;" %%i in (%tmp%) do echo  Decription: %%i
find "AUTHOR" %map% > %tmp%
echo.
for /f "tokens=2-3 delims=;" %%i in (%tmp%) do echo  Auteur: %%i %%j
find "DATE" %map% > %tmp%
for /f "tokens=2-3 delims=;" %%i in (%tmp%) do echo  Date: %%i %%j
echo.
if exist scores.txt (
   find "%score_map%" scores.txt > %tmp%
   for /f "tokens=2 delims=;" %%i in (%tmp%) do echo  Meilleur score actuel : %%i
)

:PAUSE
echo.
echo  Appuyez sur une touche...
pause > NUL
goto %go%

:LOAD
color 08
cls
echo   
echo    Chargement...
echo   
set pas=0
find "SIZE" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set size_h=%%i
for /f "tokens=3 delims=;" %%i in (%tmp%) do set size_v=%%i
echo    --- Taille : %size_h%x%size_v%
find "START" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set pos_h=%%i
set /a pos_h = %pos_h% + 1
for /f "tokens=3 delims=;" %%i in (%tmp%) do set pos_v=%%i
echo    --- Position de depart : (%pos_h%;%pos_v%)
find "EXIT" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set exit_h=%%i
set /a exit_h = %exit_h% + 1
for /f "tokens=3 delims=;" %%i in (%tmp%) do set exit_v=%%i
echo    --- Position de sortie : (%exit_h%;%exit_v%)
find "MAP%pos_v%" %map% > %tmp%
for /f "tokens=%pos_h% delims=;" %%i in (%tmp%) do set pos=%%i
echo    --- Numero de depart : %pos%
find "MAP%exit_v%" %map% > %tmp%
for /f "tokens=%exit_h% delims=;" %%i in (%tmp%) do set exit=%%i
echo    --- Numero de sortie : %exit%
echo   
echo    Lancement du jeu...
echo   
set /a cols = 43 rem + %size_h% * 5
set /a lines = 27 rem + %size_v% * 3
mode con cols=%cols% lines=%lines%
color 0F
title %title% %map%
goto GAME

:GAME
cls
echo ͻ
echo                                         
echo                   LABY                  
echo                                         
echo ͹
goto %pos%

:00
rem  inutile
echo                                         
echo                           
echo                           
echo                           
echo                           
echo                           
echo                           
echo                           
set u=0
set d=0
set l=0
set r=0
goto ACTION

:01
echo                                         
echo                           
echo                           
echo                                         
echo              ^<     ()     ^>             
echo                                         
echo                           
echo                           
set u=0
set d=0
set l=1
set r=1
goto ACTION

:02
echo                                         
echo                /\               
echo                                 
echo                                 
echo                ()               
echo                                 
echo                                 
echo                \/               
set u=1
set d=1
set l=0
set r=0
goto ACTION

:03
echo                                         
echo                /\               
echo                                 
echo                                     
echo                ()     ^>             
echo                                     
echo                           
echo                           
set u=1
set d=0
set l=0
set r=1
goto ACTION

:04
echo                                         
echo                           
echo                           
echo                                     
echo              ^<     ()               
echo                                     
echo                                 
echo                \/               
set u=0
set d=1
set l=1
set r=0
goto ACTION

:05
echo                                         
echo                           
echo                           
echo                                     
echo                ()     ^>             
echo                                     
echo                                 
echo                \/               
set u=0
set d=1
set l=0
set r=1
goto ACTION

:06
echo                                         
echo                /\               
echo                                 
echo                                     
echo              ^<     ()               
echo                                     
echo                           
echo                           
set u=1
set d=0
set l=1
set r=0
goto ACTION

:07
echo                                         
echo                           
echo                           
echo                                     
echo                ()     ^>             
echo                                     
echo                           
echo                           
set u=0
set d=0
set l=0
set r=1
goto ACTION

:08
echo                                         
echo                           
echo                           
echo                                     
echo              ^<     ()               
echo                                     
echo                           
echo                           
set u=0
set d=0
set l=1
set r=0
goto ACTION

:09
echo                                         
echo                /\               
echo                                 
echo                                 
echo                ()               
echo                                 
echo                           
echo                           
set u=1
set d=0
set l=0
set r=0
goto ACTION

:10
echo                                         
echo                           
echo                           
echo                                 
echo                ()               
echo                                 
echo                                 
echo                \/               
set u=0
set d=1
set l=0
set r=0
goto ACTION

:11
echo                                         
echo                /\               
echo                                 
echo                                     
echo                ()     ^>             
echo                                     
echo                                 
echo                \/               
set u=1
set d=1
set l=0
set r=1
goto ACTION

:12
echo                                         
echo                /\               
echo                                 
echo                                     
echo              ^<     ()               
echo                                     
echo                                 
echo                \/               
set u=1
set d=1
set l=1
set r=0
goto ACTION

:13
echo                                         
echo                           
echo                           
echo                                         
echo              ^<     ()     ^>             
echo                                         
echo                                 
echo                \/               
set u=0
set d=1
set l=1
set r=1
goto ACTION

:14
echo                                         
echo                /\               
echo                                 
echo                                         
echo              ^<     ()     ^>             
echo                                         
echo                           
echo                           
set u=1
set d=0
set l=1
set r=1
goto ACTION

:15
echo                                         
echo                /\               
echo                                 
echo                                         
echo              ^<     ()     ^>             
echo                                         
echo                                 
echo                \/               
set u=1
set d=1
set l=1
set r=1
goto ACTION

:ACTION
set /a pos_x = %pos_h% - 1
set pos_y=%pos_v%
if %pas% LSS 10 (echo  Pas : %pas%                                ) else if %pas% LSS 100 (echo  Pas : %pas%                               ) else if %pas% LSS 1000 (echo  Pas : %pas%                              ) else if %pas% LSS 10000 (echo  Pas : %pas%                             )
echo                                         
echo ͹
if %win%==1 goto END

echo                                         
echo  Ou souhaitez-vous aller ?              
echo                                         
if %u%==1 (echo      [Z] Haut                           ) else echo                                         
if %l%==1 (echo      [Q] Gauche                         ) else echo                                         
if %d%==1 (echo      [S] Bas                            ) else echo                                         
if %r%==1 (echo      [D] Droite                         ) else echo                                         
echo                                         
echo ͼ
if pro EQU %procom% goto CHPRO

:MOVE
rem choice /C ZQSD /N > NUL
set mv=0
choice /C:ZQSD /N
if "%errorlevel%"=="1" if %u%==1 (
   set /a pos_v = %pos_v% - 1
   set /a pas = %pas% + 1
)
if "%errorlevel%"=="2" if %l%==1 (
   set /a pos_h = %pos_h% - 1
   set /a pas = %pas% + 1
)
if "%errorlevel%"=="3" if %d%==1 (
   set /a pos_v = %pos_v% + 1
   set /a pas = %pas% + 1
)
if "%errorlevel%"=="4" if %r%==1 (
   set /a pos_h = %pos_h% + 1
   set /a pas = %pas% + 1
)
goto CHORSE

:CHPRO
set /p rep= [Z;Q;S;D]:
set mv=0
if %u%==1 (
	if %rep%==Z set /a pos_v = %pos_v% - 1 & set /a pas = %pas% + 1
	if %rep%==z set /a pos_v = %pos_v% - 1 & set /a pas = %pas% + 1
   set mv=1
)
if %l%==1 (
	if %rep%==Q set /a pos_h = %pos_h% - 1 & set /a pas = %pas% + 1
	if %rep%==q set /a pos_h = %pos_h% - 1 & set /a pas = %pas% + 1
   set mv=1
)
if %d%==1 (
	if %rep%==S set /a pos_v = %pos_v% + 1 & set /a pas = %pas% + 1
	if %rep%==s set /a pos_v = %pos_v% + 1 & set /a pas = %pas% + 1
   set mv=1
)
if %r%==1 (
	if %rep%==D set /a pos_h = %pos_h% + 1 & set /a pas = %pas% + 1
	if %rep%==d set /a pos_h = %pos_h% + 1 & set /a pas = %pas% + 1
   set mv=1
)
if %rep%==quitter goto QUIT
if %rep%==quit goto QUIT
if %rep%==exit goto QUIT

:CHORSE
if %pos_h%==%exit_h% if %pos_v%==%exit_v% set win=1
find "MAP%pos_v%" %map% > %tmp%
for /f "tokens=%pos_h% delims=;" %%i in (%tmp%) do set pos=%%i
rem if %mv%==1 set /a pas = %pas% + 1
goto GAME

:END
rem gros bug dans les scores
title %title% VOUS AVEZ GAGNE !
color 0A
echo                                         
echo  VOUS AVEZ GAGNE !                      
if not exist scores.txt echo %score_map%;%pas% > scores.txt else (
   find "%score_map%" scores.txt > %tmp%
   for /f "tokens=1 delims=;" %%i in (%tmp%) do set test=%%i
   echo test = %test% ; tmp = %tmp% ; score_map = %score_map% ; pas = %pas%
   pause
   if %test%=="---------- SCORES.TXT" echo %score_map%;%pas% >> scores.txt else (
      if %test% NEQ %score_map% echo %score_map%;%pas% >> scores.txt else (
         if %pas% LSS %highscore% (
            find /v "%score_map%" scores.txt > scores.tmp
            pause
            echo %score_map%;%pas% >> scores.tmp
            pause
            del /f /q scores.txt
            pause
            ren scores.tmp scores.txt
            pause
         )
      )
   )
)
if %pas% LSS %highscore% echo  Nouveau record !                       
echo                                         
echo ͼ
pause > NUL
goto CONFIG

:QUIT
title %title% BYE!
color 08
cls
echo.
echo    BYE!
del %tmp% > NUL
exit

:SCORES
cls
echo MEILLEURS SCORES
echo.
find /v "---------- SCORES.TXT" scores.txt > scores.tmp
for /f "tokens=1-2 delims=;" %%i in (scores.tmp) do echo %%i : %%j pas
del /f /q scores.tmp
set go=CHOIX
goto PAUSE