rem  CONFIG
set map=
set title=laby v0.1b
title %title% %map%
mode con cols=40 lines=30
@echo off
cls

rem  CHOIX
echo.
echo.
echo.
echo                  LABY
echo                    v0.1b
set tmp=0
echo.
echo.
echo.
echo.
echo   
echo    Choisissez une map
echo   
for /f %%i in ('DIR .\maps\*.laby /b') do echo        - %%~ni
echo   
echo    Tapez le nom de la map :
set /p map=
if not exist .\maps\%map%.laby goto QUIT

rem  INIT
set map=.\maps\%map%.laby
set tmp=%RANDOM%%RANDOM%.tmp
set go=LOAD
set win=0
set rep=0

:START
find "NAME" %map% > %tmp%
echo   
echo   
echo   
echo          *** INFORMATIONS ***
echo   
for /f "tokens=2 delims=;" %%i in (%tmp%) do echo    Nom : %%i
for /f "tokens=3 delims=;" %%i in (%tmp%) do echo    Decription: %%i
find "AUTHOR" %map% > %tmp%
echo   
for /f "tokens=2-3 delims=;" %%i in (%tmp%) do echo    Auteur: %%i %%j
find "DATE" %map% > %tmp%
for /f "tokens=2-3 delims=;" %%i in (%tmp%) do echo    Date: %%i %%j

:PAUSE
echo   
echo    Appuyez sur une touche...
pause > NUL
goto %go%

:LOAD
color 08
cls
echo   
echo    Chargement...
echo   
find "SIZE" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set size_h=%%i
for /f "tokens=3 delims=;" %%i in (%tmp%) do set size_v=%%i
echo    --- Taille : %size_h%x%size_v%
find "START" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set pos_h=%%i
set /a pos_h = %pos_h% + 1
for /f "tokens=3 delims=;" %%i in (%tmp%) do set pos_v=%%i
echo    --- Position de depart : (%pos_h%;%pos_v%)
find "EXIT" %map% > %tmp%
for /f "tokens=2 delims=;" %%i in (%tmp%) do set exit_h=%%i
set /a exit_h = %exit_h% + 1
for /f "tokens=3 delims=;" %%i in (%tmp%) do set exit_v=%%i
echo    --- Position de sortie : (%exit_h%;%exit_v%)
find "MAP%pos_v%" %map% > %tmp%
for /f "tokens=%pos_h% delims=;" %%i in (%tmp%) do set pos=%%i
echo    --- Numero de depart : %pos%
find "MAP%exit_v%" %map% > %tmp%
for /f "tokens=%exit_h% delims=;" %%i in (%tmp%) do set exit=%%i
echo    --- Numero de sortie : %exit%
echo   
echo    Lancement du jeu...
echo   
mode con cols=40 lines=25
color 0F
title %title% %map%
goto GAME

:GAME
cls
echo  %title% %map%
echo.
echo 
goto %pos%

:00
rem  inutile
echo.
echo              
echo              
echo              
echo              
echo              
echo              
echo              
set u=0
set d=0
set l=0
set r=0
goto ACTION

:01
echo.
echo              
echo              
echo.
echo              ^<     ()     ^>
echo.
echo              
echo              
set u=0
set d=0
set l=1
set r=1
goto ACTION

:02
echo.
echo                /\  
echo                    
echo                    
echo                ()  
echo                    
echo                    
echo                \/  
set u=1
set d=1
set l=0
set r=0
goto ACTION

:03
echo.
echo                /\  
echo                    
echo              
echo                ()     ^>
echo              
echo              
echo              
set u=1
set d=0
set l=0
set r=1
goto ACTION

:04
echo.
echo              
echo              
echo                        
echo              ^<     ()  
echo                        
echo                    
echo                \/  
set u=0
set d=1
set l=1
set r=0
goto ACTION

:05
echo.
echo              
echo              
echo              
echo                ()     ^>
echo              
echo                    
echo                \/  
set u=0
set d=1
set l=0
set r=1
goto ACTION

:06
echo.
echo                /\  
echo                    
echo                        
echo              ^<     ()  
echo                        
echo              
echo              
set u=1
set d=0
set l=1
set r=0
goto ACTION

:07
echo.
echo              
echo              
echo              
echo                ()     ^>
echo              
echo              
echo              
set u=0
set d=0
set l=0
set r=1
goto ACTION

:08
echo.
echo              
echo              
echo                        
echo              ^<     ()  
echo                        
echo              
echo              
set u=0
set d=0
set l=1
set r=0
goto ACTION

:09
echo.
echo                /\  
echo                    
echo                    
echo                ()  
echo                    
echo              
echo              
set u=1
set d=0
set l=0
set r=0
goto ACTION

:10
echo.
echo              
echo              
echo                    
echo                ()  
echo                    
echo                    
echo                \/  
set u=0
set d=1
set l=0
set r=0
goto ACTION

:11
echo.
echo                /\  
echo                    
echo              
echo                ()     ^>
echo              
echo                    
echo                \/  
set u=1
set d=1
set l=0
set r=1
goto ACTION

:12
echo.
echo                /\  
echo                    
echo                        
echo              ^<     ()  
echo                        
echo                    
echo                \/  
set u=1
set d=1
set l=1
set r=0
goto ACTION

:13
echo.
echo              
echo              
echo.
echo              ^<     ()     ^>
echo.
echo                    
echo                \/  
set u=0
set d=1
set l=1
set r=1
goto ACTION

:14
echo.
echo                /\  
echo                    
echo.
echo              ^<     ()     ^>
echo.
echo              
echo              
set u=1
set d=0
set l=1
set r=1
goto ACTION

:15
echo.
echo                /\  
echo                    
echo.
echo              ^<     ()     ^>
echo.
echo                    
echo                \/  
set u=1
set d=1
set l=1
set r=1
goto ACTION

:ACTION
set /a pos_x = %pos_h% - 1
set pos_y=%pos_v%
echo  (%pos_x%;%pos_y%)
echo.
echo 
if %win%==1 goto END

echo  Ou souhaitez-vous aller ?
echo.
if %u%==1 (echo      [Z] Haut) else echo.
if %l%==1 (echo      [Q] Gauche) else echo.
if %d%==1 (echo      [S] Bas) else echo.
if %r%==1 (echo      [D] Droite) else echo.
echo.
set /p rep= [Z;Q;S;D]:
if %u%==1 (
	if %rep%==Z set /a pos_v = %pos_v% - 1
	if %rep%==z set /a pos_v = %pos_v% - 1
)
if %l%==1 (
	if %rep%==Q set /a pos_h = %pos_h% - 1
	if %rep%==q set /a pos_h = %pos_h% - 1
)
if %d%==1 (
	if %rep%==S set /a pos_v = %pos_v% + 1
	if %rep%==s set /a pos_v = %pos_v% + 1
)
if %r%==1 (
	if %rep%==D set /a pos_h = %pos_h% + 1
	if %rep%==d set /a pos_h = %pos_h% + 1
)
if %rep%==quit goto QUIT
if %rep%==exit goto QUIT
if %pos_h%==%exit_h% if %pos_v%==%exit_v% set win=1
find "MAP%pos_v%" %map% > %tmp%
for /f "tokens=%pos_h% delims=;" %%i in (%tmp%) do set pos=%%i
goto GAME

:END
title %title% GAGNE !
color 0A
echo.
echo    GAGNE !
set go=QUIT
goto PAUSE

:QUIT
title %title% BYE!
color 08
cls
echo.
echo    BYE!
if %tmp%==0 exit
del %tmp%
exit